Attribute VB_Name = "Bibo"
Option Explicit

Public Const DiskSize As Long = 734003200
Public Const MediaNotSet As Long = -1

Public Type FileType
    Size As Long
    Media As Long
    Name As String
End Type

Public Type MediaType
    Size As Long
    Files() As Long
    FileCnt As Long
End Type
    

Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
                         Alias "SHBrowseForFolderA" ( _
                         lpBrowseInfo As BROWSEINFO) As Long
                         
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" _
                         Alias "SHGetPathFromIDListA" ( _
                         ByVal pidl As Long, _
                         ByVal pszPath As String) As Long
                         
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000

Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Public Enum Flag

    ' //Nach Drucker im Netzwerk suchen lassen
    BrowseForPrinter = BIF_BROWSEFORPRINTER
    
    ' //Nach Computer im Netzwerk suchen lassen
    BrowseForComputer = BIF_BROWSEFORCOMPUTER
    
    ' //Nach lokalem oder Netzwerkordner suchen lassen
    BrowseForFolder = BIF_RETURNONLYFSDIRS
    
    ' //Nur lokale Ordner zur Auswahl zulassen
    BrowseForLocalFolder = BIF_RETURNFSANCESTORS
End Enum

Private Declare Function FindFirstFile Lib "kernel32" _
        Alias "FindFirstFileA" (ByVal lpFileName As String, _
        lpFindFileData As WIN32_FIND_DATA) As Long
        
Private Declare Function FindNextFile Lib "kernel32" _
        Alias "FindNextFileA" (ByVal hFindFile As Long, _
        lpFindFileData As WIN32_FIND_DATA) As Long
        
Private Declare Function FindClose Lib "kernel32" (ByVal _
        hFindFile As Long) As Long

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Const MAX_PATH As Long = 259&

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Const FILE_ATTRIBUTE_ARCHIVE As Long = &H20&
Const FILE_ATTRIBUTE_COMPRESSED As Long = &H800&
Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10&
Const FILE_ATTRIBUTE_HIDDEN As Long = &H2&
Const FILE_ATTRIBUTE_NORMAL As Long = &H80&
Const FILE_ATTRIBUTE_READONLY As Long = &H1&
Const FILE_ATTRIBUTE_SYSTEM As Long = &H4&
Const FILE_ATTRIBUTE_TEMPORARY As Long = &H100&

Private Sub BubbleSort(ByRef Files() As FileType)
    Dim Changes As Boolean, TEMP As Long
    Dim UpperBound As Long, X As Long
    
    UpperBound = UBound(Files) - 1
    Changes = False
    Do While Not Changes
        Changes = True
        For X = 0 To UpperBound
            If Files(X).Size < Files(X + 1).Size Then
                TEMP = Files(X).Size
                Files(X).Size = Files(X + 1).Size
                Files(X + 1).Size = TEMP
                Changes = False
                UpperBound = X
            End If
        Next
    Loop
End Sub

Public Function Extract(str As String, endTag As String) As String
    Dim startPos As Long, endPos As Long
    If str = "" Then Exit Function
    endPos = InStr(1, str, endTag)
    Extract = Left(str, endPos - 1)
End Function

Public Function CountString(Expression As String, Search As String) As String
    Dim cnt As Long, lastPos As Long
    lastPos = InStr(1, Expression, Search)
    Do While lastPos > 0
        cnt = cnt + 1
        lastPos = InStr(lastPos + 1, Expression, Search)
    Loop
    CountString = cnt
End Function

Public Function GetAllFiles(ByVal Root As String, _
    ByVal Such As String, ByRef Field() As String, _
    Optional DoRecursion As Boolean = False, _
    Optional UsedField As Long = 0) As Long
    
    Dim File As String
    Dim hFile As Long
    Dim FD As WIN32_FIND_DATA
    
    ' Evtl. Array vergrern?
    If (UsedField = UBound(Field)) Then
        ReDim Preserve Field(UBound(Field) + 100)
    End If
    
    DoEvents
    
    'Backslash ergnzen
    If Right(Root, 1) <> "\" Then Root = Root & "\"
    
    ' Die erste Datei suchen
    hFile = FindFirstFile(Root & "*.*", FD)
    
    ' Es konnte nichts gefunden werden
    If hFile = 0 Then
        GetAllFiles = 0
        Exit Function
    End If
    
    ' Fr jede Datei
    Do
        ' Den Dateinamen extrahieren
        File = Left(FD.cFileName, InStr(FD.cFileName, Chr(0)) - 1)
        
        ' Ist die Datei ein Verzeichnis?
        If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) _
            = FILE_ATTRIBUTE_DIRECTORY Then
            
            ' . und .. ignorieren
            If (File <> ".") And (File <> "..") Then
            
                ' Unterordner auch durchsuchen?
                If DoRecursion Then
                    
                    ' Unterordner rekursiv erfassen
                    Form1.PathLbl.Caption = Root & File
                    GetAllFiles = GetAllFiles + GetAllFiles(Root & File, _
                        Such, Field, DoRecursion, UsedField)
                    Form1.PathLbl.Caption = Root
                Else
                    
                    ' Ergebnis speichern
                    ' Verzeichnis: ">>" kann entfernt werden,
                    ' da nur zur Visualisierung
                    Field(UsedField) = ">>" & Root & File
                    GetAllFiles = GetAllFiles + 1
                    UsedField = UsedField + 1
                    
                    ' Evtl. Array vergrern
                    If (UsedField = UBound(Field)) = 0 Then
                        ReDim Preserve Field(0 To UBound(Field) + 100)
                    End If
                End If
            End If
        Else
            
            ' Passt das Suchmuster?
            If (Such Like Right$(UCase$(File), Len(Such))) Or Such = "*" Then
                
                ' Ergebnis speichern
                ' Datei: "    " kann entfernt werden,
                ' da nur zur Visualisierung
                Field(UsedField) = "    " & Root & File
                GetAllFiles = GetAllFiles + 1
                UsedField = UsedField + 1
                
                ' Evtl. Array vergrern
                If (UsedField = UBound(Field)) Then
                    ReDim Preserve Field(0 To UBound(Field) + 100)
                End If
            End If
        End If
    
    ' Nchste Datei suchen
    Loop While FindNextFile(hFile, FD)
    
    ' Suchhandle wieder freigeben - Suche beenden
    Call FindClose(hFile)
End Function

Public Function ShowSelection(ByVal hWnd As Long, Title As String, Optional dwFlag As _
    Flag = BIF_RETURNONLYFSDIRS) As String
    
    Dim bi As BROWSEINFO
    Dim pidl As Long
    Dim strFolder As String
    
    strFolder = String$(255, vbNullChar)
    
    With bi
    
        .hOwner = hWnd
        .ulFlags = dwFlag
        .pidlRoot = 0
        .lpszTitle = Title
        
    End With
    
    pidl = SHBrowseForFolder(bi)
    
    ShowSelection = IIf(SHGetPathFromIDList(ByVal pidl, ByVal strFolder), Left$( _
        strFolder, InStr(strFolder, vbNullChar) - 1), vbNullString)
End Function


