Attribute VB_Name = "modModule"
Option Explicit

Private Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10
Private Const MAX_PATH As Long = 259

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Public Type FileAndSize
    File As String
    Size As Currency
End Type

Private Declare Function FindFirstFile Lib "kernel32" _
                         Alias "FindFirstFileA" ( _
                         ByVal lpFileName As String, _
                         ByRef lpFindFileData As WIN32_FIND_DATA) As Long
                         
Private Declare Function FindNextFile Lib "kernel32" _
                         Alias "FindNextFileA" ( _
                         ByVal hFindFile As Long, _
                         ByRef lpFindFileData As WIN32_FIND_DATA) As Long
                         
Private Declare Function FindClose Lib "kernel32" ( _
                         ByVal hFindFile As Long) As Long
                         
Public m_Files() As FileAndSize

' http://www.activevb.de/tipps/vb6tipps/tipp0188.html
' VB 5/6-Tipp 0188: Sortieren mit Quicksort
' entsprechend angepasst
Public Sub QuickSort(ByVal LB As Long, ByVal UB As Long)

    Dim P1 As Long, P2 As Long
    Dim Ref As Currency, TEMP As Currency
    Dim Var As String
    
    P1 = LB
    P2 = UB
    Ref = m_Files((P1 + P2) / 2).Size
    
    Do
        Do While (m_Files(P1).Size < Ref)
            P1 = P1 + 1
        Loop
        
        Do While (m_Files(P2).Size > Ref)
            P2 = P2 - 1
        Loop
        
        If P1 <= P2 Then
            Var = m_Files(P1).File
            TEMP = m_Files(P1).Size
            
            m_Files(P1).File = m_Files(P2).File
            m_Files(P1).Size = m_Files(P2).Size
            
            m_Files(P2).File = Var
            m_Files(P2).Size = TEMP
            
            P1 = P1 + 1
            P2 = P2 - 1
        End If
        
    Loop Until (P1 > P2)
    
    If LB < P2 Then Call QuickSort(LB, P2)
    If P1 < UB Then Call QuickSort(P1, UB)
    
End Sub

' http://www.activevb.de/tipps/vb6tipps/tipp0128.html
' VB 5/6-Tipp 0128: Dateien und Verzeichnisse rekursiv suchen
' entsprechend angepasst
Public Function GetAllFiles(ByVal Root As String, ByVal Search As String, ByRef _
    Field() As FileAndSize, Optional DoRecursion As Boolean = False, Optional _
    UsedField As Long = 0) As Long
    
    Dim File As String
    Dim hFile As Long
    Dim FD As WIN32_FIND_DATA
    
    ' Evtl. Array vergrern?
    If (UsedField = UBound(Field)) Then
        ReDim Preserve Field(UBound(Field) + 100)
    End If
    
    DoEvents
    
    ' Backslash ergnzen
    If Right(Root, 1) <> "\" Then Root = Root & "\"
    
    ' Die erste Datei suchen
    hFile = FindFirstFile(Root & "*.*", FD)
    
    ' Es konnte nichts gefunden werden
    If hFile = 0 Then
        GetAllFiles = 0
        
        Exit Function
        
    End If
    
    ' Fr jede Datei
    Do
    
        ' Den Dateinamen extrahieren
        File = Left(FD.cFileName, InStr(FD.cFileName, vbNullChar) - 1)
        
        ' Ist die Datei ein Verzeichnis?
        If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = _
            FILE_ATTRIBUTE_DIRECTORY Then
            
            ' . und .. ignorieren
            If (File <> ".") Then
                If (File <> "..") Then
                
                    ' Unterordner auch durchsuchen?
                    If DoRecursion Then
                    
                        ' Unterordner rekursiv erfassen
                        GetAllFiles = GetAllFiles + GetAllFiles(Root & File, _
                            Search, Field, DoRecursion, UsedField)
                            
                    End If
                End If
            End If
            
        Else
        
            ' Passt das Suchmuster?
            If (Search Like Right$(UCase$(File), Len(Search))) Or Search = "*" Then
            
                ' Ergebnis speichern
                Field(UsedField).File = Root & File
                Field(UsedField).Size = (FD.nFileSizeHigh * &HFFFF) + FD.nFileSizeLow
                
                GetAllFiles = GetAllFiles + 1
                UsedField = UsedField + 1
                
                ' Evtl. Array vergrern
                If (UsedField = UBound(Field)) Then
                    ReDim Preserve Field(0 To UBound(Field) + 100)
                End If
            End If
        End If
        
        ' Nchste Datei suchen
    Loop While FindNextFile(hFile, FD)
    
    ' Handle wieder freigeben - Suche beenden
    Call FindClose(hFile)
    
End Function
