﻿Module Backup

    'Ein Datenträger speichert 700MB...
    Const DISK_SIZE As Long = 700 * 1024

    Sub Main()
        Dim startTime As Date = Date.Now

        'Was passiert hier - die Datei blist.txt wird eingelesen und Zeilenweiste in ein Array gepackt. Danach wird über ConvertAll die List(of String) in List(of Int) gecastet und das ganze dann noch mit Linq absteigend sortiert und am Ende wider in List(of Int) umgewandelt
        'Und wir sehen, der Kommentar wurde tatsächlich noch länger als die Zeile...
        Dim list = (From size In My.Computer.FileSystem.ReadAllText("C:\blist.txt").Split(vbCrLf).ToList().ConvertAll(New Converter(Of String, Integer)(AddressOf Convert.ToInt32)) Order By CInt(size) Descending).ToList
        'Noch mehr Deklarationen
        Dim freeSpace As Long = DISK_SIZE, i As Long, diskNumber As Long = 0
        Dim sizeSum As Long = 0, unusedSpace As Long = 0

        Console.WriteLine("Anzhal der Dateien: " & list.Count)
        'Kurze Erklährung wie es geht - wir haben eine Liste mit den Dateigrößen,
        'so sortiert, dass die großen zuerst kommen. Diese gehen wir solange durch
        'bis nichts mehr in ihr ist. Es werden nun immer die Datei auf den
        'Datenträger kopiert, die am meisten Platz benötigt - wenn dies nicht mehr geht
        'wird ein neuer Datenträger begonnen.
        While list.Count > 0
            i = 0
            'Größte passende Datei suchen
            While (i < list.Count AndAlso freeSpace - list(i) < 0) : i += 1 : End While

            'Gefunden?
            If list.Count() - i > 0 Then
                'Datei kann hier nun auf den Datenträger kopieren...
                freeSpace -= list(i)
                sizeSum += list(i)
                list.RemoveAt(i)
            Else
                diskNumber += 1
                Console.WriteLine("Datenträger " & diskNumber & ": " & freeSpace) 'Neuer Datenträger einlegen ;)
                unusedSpace += freeSpace
                freeSpace = DISK_SIZE
            End If
        End While
        diskNumber += 1
        Console.WriteLine("Anzahl an Datenträgern " & diskNumber)
        Console.WriteLine("Datenmenge: " & sizeSum & "kB")
        Console.WriteLine("Nichtgenutzer Speicherplatz: " & unusedSpace & "kB (" & (100 / (diskNumber * DISK_SIZE) * unusedSpace) & "%)")
        Console.WriteLine("Dauer: " & (Date.Now - startTime).Milliseconds & "ms")

        'Nochmal probieren, vielleicht wirds ja schneller..
        'wird es komischerweise auch bei allen weiteren versuchen - der JIT
        'cached wohl das einlesen/sortieren/casten von der list Variable
        If Console.ReadKey().KeyChar = "r" Then
            Console.WriteLine()
            Main()
        End If
    End Sub
End Module
